EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_layout_signal_message_send, EFL_FUNC_CALL(id, msg), int id, const Eina_Value msg);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_layout_signal_callback_add, Eina_Bool, 0, EFL_FUNC_CALL(emission, source, func_data, func, func_free_cb), const char *emission, const char *source, void *func_data, EflLayoutSignalCb func, Eina_Free_Cb func_free_cb);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_layout_signal_callback_del, Eina_Bool, 0, EFL_FUNC_CALL(emission, source, func_data, func, func_free_cb), const char *emission, const char *source, void *func_data, EflLayoutSignalCb func, Eina_Free_Cb func_free_cb);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_layout_signal_emit, EFL_FUNC_CALL(emission, source), const char *emission, const char *source);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_layout_signal_process, EFL_FUNC_CALL(recurse), Eina_Bool recurse);

static Eina_Bool
_efl_layout_signal_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_LAYOUT_SIGNAL_EXTRA_OPS
#define EFL_LAYOUT_SIGNAL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_layout_signal_message_send, NULL),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_callback_add, NULL),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_callback_del, NULL),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_emit, NULL),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_process, NULL),
      EFL_LAYOUT_SIGNAL_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_layout_signal_class_desc = {
   EO_VERSION,
   "Efl.Layout.Signal",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_layout_signal_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_layout_signal_interface_get, &_efl_layout_signal_class_desc, NULL, NULL);
